# Copyright (c) 2000-2013, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without maven

%define section     free
%define short_name  neethi
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           ws-commons-neethi3
Version:        3.0.1
Release:        2%{?dist}
Epoch:          0
Summary:        Apache Neethi WS-Policy implementation 
License:        ASL 2.0
Group:          Text Processing/Markup/XML
URL:            http://ws.apache.org/commons/neethi/index.html
# svn -q export http://svn.apache.org/repos/asf/webservices/commons/tags/neethi/neethi-3.0.1/ && tar cjf neethi-3.0.1.tar.bz2 neethi-3.0.1
Source0:        %{short_name}-%{version}.tar.bz2
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        %{name}-build.xml
Patch0:         ws-commons-neethi3-pom.patch

Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  jdepend
BuildRequires:  junit >= 0:3.8.2
%if %with maven
BuildRequires:  maven2 >= 2.0.8
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-one
BuildRequires:  maven2-plugin-project-info-reports
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven-skins
BuildRequires:  maven-jxr
BuildRequires:  maven-release
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  mojo-maven2-plugin-jdepend
%endif
BuildRequires:  ws-commons-axiom >= 0:1.2.12
BuildRequires:  wstx
BuildRequires:  stax_1_0_api
BuildRequires:  apache-commons-logging
BuildRequires:  wsdl4j >= 0:1.6.2

Requires:       jpackage-utils >= 0:1.7.5
Requires:       java >= 0:1.6.0
Requires:       ws-commons-axiom >= 0:1.2.12
Requires:       wstx
Requires:       stax_1_0_api
Requires:       apache-commons-logging
Requires:       wsdl4j >= 0:1.6.2

# ws-commons-policy has NOT been renamed to neethi
Provides:   neethi = %{epoch}:%{version}-%{release}
Obsoletes:  neethi <= 0:1.0.1
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Apache Neethi provides an implementation of WS-Policy specification.It
provides a convenient model to process any policy information at
runtime. In other words, it allows you to convert any policy to an
object (which is its runtime representation) and play with it as you
like.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n %{short_name}-%{version}
cp -p %{SOURCE1} settings.xml
cp -p %{SOURCE3} build.xml
%patch0 -b .sav0

%build
%if %with maven
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        -Dmaven2.jpp.mode=true \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        install javadoc:javadoc site
%else
export OPT_JAR_LIST=
export CLASSPATH=$(build-classpath \
stax_1_0_api \
ws-commons-axiom-api \
ws-commons-axiom-impl \
wstx/wstx-asl \
)
CLASSPATH=$CLASSPATH:target/classes:target/test-classes
%{ant} -Dbuild.sysclasspath=only jar test javadoc
%endif

%install
rm -rf $RPM_BUILD_ROOT

install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -p -m 644 target/%{short_name}-%{version}.jar \
           $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%add_to_maven_depmap org.apache.neethi neethi %{version} JPP %{name}

# create unprefixed and unversioned symlinks
(cd $RPM_BUILD_ROOT%{_javadir}
for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done
ln -s %{name}.jar %{short_name}3.jar
)

# poms
%if %with maven
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -p -m 644 pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.pom
%endif

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p *.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
%if %with maven
cp -pr target/site/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
rm -rf $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/apidocs
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap 

%files
%defattr(0644,root,root,0755)
%dir %{_docdir}/%{name}-%{version}
%doc %{_docdir}/%{name}-%{version}/*
%{_javadir}/*.jar
%{_datadir}/maven2/poms/JPP.%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%changelog
* Mon Feb 04 2013 Ralph Apel <r.apel at r-apel.de> 0:3.0.1-2
- Prevent xzpayload problem

* Fri Jan 11 2012 Ralph Apel <r.apel at r-apel.de> 0:3.0.1-1
- 3.0.1 as ws-commons-neethi3

* Mon Nov 28 2011 Ralph Apel <r.apel at r-apel.de> 0:2.0.4-2
- (B)R wstx instead of wstx32, apache-commons-logging

* Tue Jul 28 2009 David Walluck <dwalluck@redhat.com> 0:2.0.4-1
- 2.0.4

* Mon Mar 23 2009 Ralph Apel <r.apel at r-apel.de> 0:2.0.1-4.jpp5
- (B)R wstx32 because wstx is frozen to 3.1.1 in JPP-5

* Mon Feb 09 2009 Ralph Apel <r.apel at r-apel.de> 0:2.0.1-3.jpp5
- Rebuild with current best practices

* Wed Jul 11 2007 Ralph Apel <r.apel at r-apel.de> 0:2.0.1-2jpp
- Remove false Provides/Obsoletes ws-commons-policy

* Wed May 30 2007 Ralph Apel <r.apel at r-apel.de> 0:2.0.1-1jpp
- Upgrade to 2.0.1
- Build with maven2 by default
- Make Vendor, Distribution based on macro
- Add gcj_support option

* Fri May 19 2006 Deepak Bhole <dbhole@redhat.com> 0:1.0-1jpp
- Initial build
